Subject: RE: bug#24510: 25.1; Info: searching for ` does not find what looks like `

From: Drew Adams <[email-masked]>
Date: Fri, 23 Sep 2016 09:02:32 -0700 (PDT)

> > Again, this is emacs -Q.
> 
> That doesn't matter, since Emacs doesn't control the fonts
> installed on the user's system, much less how they look.

IIUC, Emacs tries to influence the default font, even if it
cannot completely control what it will be.  And the font in
question is one of the most common (on MS Windows).

> Like I said: if some
> user cannot distinguish between these characters, I see no other
> solution for the problem except font customizations, since only the
> user on her system can DTRT with the fonts that are available.

Are you saying that Emacs has no role in guiding the default
font toward being Courier New on MS Windows - that there is no
way to guide it toward being another font?  Emacs has no influence
at all on which font is used by default?

In that case, indeed, we have a usability problem, Houston,
since this is a very common fixed-width font.

> > The chars look quite different with my own setup - this is
> > not a problem for me, personally.
> 
> Then what exactly is the nature of the problem you raise?

emacs -Q on MS Windows, as stated.  It's not about me (or
my setup).  I don't use emacs -Q, except to look into bugs.

> Is it a hypothetical issue that _might_ happen on someone's
> machine, even though none of us, including yourself, have
> actually witnessed it?

It is a real problem, which I witness systematically with
emacs -Q.  It is, I expect, a real problem for many, even
most, users on MS Windows.

Why do you insist on saying things like "none of us,
including yourself, have actually witnessed it?"

What is the point of such a preposterous claim?  Clearly
I _have_ witnessed the problem and reported it, including
showing a screenshot.  If you refuse to see that the
emperor has no clothes, that's not my fault.  I and my
little camera are witness.

> > > It might, if you turn on character-folding in Isearch.
> > > Unfortunately, that is off by default.
> >
> > I did mention that this is what a user sees by DEFAULT, no?
> 
> Weren't you one of those who lobbied for turning the character-folding
> off by default?  If it were not for that lobbying, your search would
> have succeeded.

No.  And there was no such "lobbying", by anyone.  Can you point
to any post by me, in the long and deep discussion about this on
emacs-devel ("On language-dependent defaults for character-folding")
where I did that?
 
And why would it be important if I had?  Are you trying to
mete out punishment, saying that it is my fault that Emacs
now presents, by default, a visual confusion of single-quoting?
You didn't get your way, but that's not my fault.

FYI, this is what I _actually_ said, in reply to your insistence
that the feature be on by default for 25.1, after the consensus
seemed to have been reached to leave it off by default (there
was one dissenter -you- and several, like me, for whom the
default behavior was much less important than other questions):

d>  I don't see anyone proposing to throw out the bathwater,
d>  much less the baby with it.
d>  
d>  Eli, you say here, quite often, that you think discussions
d>  about what the default behavior of a feature should be are
d>  typically fruitless, if not sterile.  But it seems clear
d>  that you care quite a lot about this default behavior.
d>  
d>  I'd say let it go.  There will be Emacs 25.2 and beyond.
d>  And users will try this new feature and give their feedback,
d>  which I expect will be overwhelmingly positive - and
d>  informative for further discussions here.
d>  
d>  Based on user feedback and further discussion and analysis
d>  here (this is not going away), Emacs Dev will improve and
d>  elaborate this feature.  We will have better ideas about how
d>  to handle all of the things that are currently not so clear.
d>  There is plenty of time to decide again whether this or that
d>  should be turned on by default.
d>  
d>  What seems clear to me for Emacs 25.1 is that the feature
d>  should be included AND that it should be simple to both (1)
d>  customize the default behavior for a given user (i.e., what
d>  behavior search starts with, a la `case-fold-search') and
d>  (2) toggle the behavior on the fly, during Isearch.
d>  
d>  Given (1) and (2), users can do what they like, and we can
d>  learn later from them what behaviors might best be adopted
d>  for defaulting.

And this is John's response to that:

 d> What seems clear to me for Emacs 25.1 is that the feature
 d> should be included AND that it should be simple to both (1)
 d> customize the default behavior for a given user (i.e., what
 d> behavior search starts with, a la `case-fold-search') and
 d> (2) toggle the behavior on the fly, during Isearch.
j>
j> I think Drew has summarized perfectly what I would like to
j> see happen. In addition, I'd add one more item: Once 25.1 is
j> released, I (or another) will write a blog article publicizing
j> this feature and touting its benefits, in order to encourage
j> people to try it out and discover how useful it can be.
j> 
j> However, making it a default in 25.1 is something I am simply
j> not comfortable doing, giving the diversity of opinion on this
j> list, plus my own misgivings about so new (and nuanced) a
j> feature. Yes, the visual equality of á and á is a powerful
j> argument, but as Drew said, there will be well-advertised ways
j> to both enable this feature, and to toggle it while searching.
j> Users will not lose any capacity by our decision, they will
j> simply not experience it as a default out of the box.
j> 
j> And so, my decision is that this feature will be off by default
j> in the 25.1 release, with the genuine hope that it can be made
j> solid enough to become a default in a future release. It
j> needn't even wait until 26.1, if we receive enough positive feedback.
j> 
j> My thanks to everyone for the extensive and conscientious debate,
j> and to Eli for sticking to his guns.  I am hopeful we will reach
j> general consensus over time, and that this feature will come to
j> be recognized as a compelling aspect of the Emacs feature set.
j> Until that day, please forgive me my reservations; I'm just not
j> there yet in wanting this to become a default behavior.

"Sticking to his guns" was a "nice" way to put it.
And he seems to still be brandishing them.

> > > Emacs doesn't provide any fonts.  Your system does.  On my system,
> > > these two characters look different, even with my old weary eyes.
> >
> > They look slightly different, yes.  Barely noticeable when you
> > see them side by side (see screenshot).
> 
> The look quite different to me (my system uses the same font),

You _know_ they are different.  Please look again at the screenshot
I sent, and imagine that it does not include the window showing the
two right next to each other, so you see what a user sees when s?he
searches for `.

It is not at all obvious, I would argue, that the ` in the Isearch
search string is a different character from the left quotation mark
in the *info* buffer.  And things are even less obvious if the user
cannot immediately see an occurrence of the latter character - e.g.,
when starting a search across nodes.

> so I guess we will have to agree to disagree about that.

Indeed we shall.

> I'm not dismissing the problem.  I'm saying that I don't see a
> solution except through user customizations.  Searching for similarly
> looking characters is not specific to Info, it can happen elsewhere.
> Users who bump into that frequently should customize their fonts
> and/or turn on character-folding in search commands.

That's not a solution for the default behavior, which is what
this bug is about.  If that is what you propose to solve the
problem here then you are indeed dismissing the problem.

Two possible solutions have been suggested in this thread, so far:

1) Emacs can try to avoid using Courier New as the default font.
2. Isearch can fold "single-quote" chars (i.e., chars that could
   be confused in this regard), by default.

Please note, BTW, that I have _not_ opposed #2, just as I did
_not_ "lobby for turning the character-folding off by default"
during the general emacs-devel discussion.

I think #1 is generally preferable.  Other solution proposals
are welcome.  What's not helpful is dismissing the problem or
casting blame for it.